diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
index fc4baade8..d315bc946 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
@@ -3,7 +3,7 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld;
 import java.util.Random;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
@@ -53,8 +53,8 @@ public class SurfaceGeneratorOverworld
         int chunkX = chunk.xPosition;
         int chunkZ = chunk.zPosition;
 
-        int oceanBlock = world.getWorldType().getOceanBlock();
-        int worldFillBlock = world.getWorldType().getFillerBlock();
+        int oceanBlock = world.getWorldType().getOceanBlockId();
+        int worldFillBlock = world.getWorldType().getFillerBlockId();
 
         Random rand = new Random((long) chunkX * 0x4F9939F508L + (long) chunkZ * 0x1EF1565BD5L);
 
@@ -157,24 +157,24 @@ public class SurfaceGeneratorOverworld
                                 fillerBlock = biome.fillerBlock;
                                 if(biomeGeneratesMud)
                                 {
-                                    topBlock = (short) Block.mud.id;
-                                    fillerBlock = (short) Block.mud.id;
+                                    topBlock = (short) Blocks.MUD.id;
+                                    fillerBlock = (short) Blocks.MUD.id;
                                 }
                                 else if(generateGravelBeach)
                                 {
                                     topBlock = 0;
-                                    fillerBlock = (short) Block.gravel.id;
+                                    fillerBlock = (short) Blocks.GRAVEL.id;
                                 }
                                 else if(generateSandBeach)
                                 {
-                                    topBlock = (short) Block.sand.id;
-                                    fillerBlock = (short) Block.sand.id;
+                                    topBlock = (short) Blocks.SAND.id;
+                                    fillerBlock = (short) Blocks.SAND.id;
                                 }
                             } else if (y <= oceanY) {
                                 if(biomeGeneratesMud) // Make mud under the ocean always be regular mud
                                 {
-                                    topBlock = (short) Block.mud.id;
-                                    fillerBlock = (short) Block.mud.id;
+                                    topBlock = (short) Blocks.MUD.id;
+                                    fillerBlock = (short) Blocks.MUD.id;
                                 }
                             }
                         }
@@ -209,7 +209,21 @@ public class SurfaceGeneratorOverworld
                             {
                                 if (generateBasaltLayer)
                                 {
-                                    result.setBlock(x, y, z, Block.basalt.id);
+                                    result.setBlock(x, y, z, Blocks.BASALT.id);
+                                    continue;
+                                }
+                            }
+                            if(biome == Biomes.OVERWORLD_GLACIER){
+                                if (y >= (minY + 56 + graniteThicknessLevel/4 - rand.nextInt(3)) && y <= maxY)
+                                {
+                                    result.setBlock(x, y, z, Blocks.PERMAFROST.id);
+                                    continue;
+                                }
+                            }
+                            if(biome == Biomes.OVERWORLD_TUNDRA){
+                                if (y >= (minY + 56 + graniteThicknessLevel/4 - rand.nextInt(3)) && y <= (minY + (56 + 36) + graniteThicknessLevel/8 - rand.nextInt(3)))
+                                {
+                                    result.setBlock(x, y, z, Blocks.PERMAFROST.id);
                                     continue;
                                 }
                             }
@@ -217,7 +231,7 @@ public class SurfaceGeneratorOverworld
                             {
                                 if (generateGraniteLayer)
                                 {
-                                    result.setBlock(x, y, z, Block.granite.id);
+                                    result.setBlock(x, y, z, Blocks.GRANITE.id);
                                     continue;
                                 }
                             }
@@ -225,7 +239,7 @@ public class SurfaceGeneratorOverworld
                             {
                                 if (generateLimestoneLayer)
                                 {
-                                    result.setBlock(x, y, z, Block.limestone.id);
+                                    result.setBlock(x, y, z, Blocks.LIMESTONE.id);
                                     continue;
                                 }
                             }
@@ -243,12 +257,12 @@ public class SurfaceGeneratorOverworld
                     // if reached end of filler layer, fill world with sandstone/permafrost if inside a glacier or desert biome
                     if(currentLayerDepth == 0)
                     {
-                        if(biome == Biomes.OVERWORLD_DESERT && fillerBlock == Block.sand.id) {
+                        if(biome == Biomes.OVERWORLD_DESERT && fillerBlock == Blocks.SAND.id) {
                             currentLayerDepth = rand.nextInt(8) + 2;
-                            fillerBlock = (short)Block.sandstone.id;
-                        } else if(biome == Biomes.OVERWORLD_GLACIER && fillerBlock == Block.blockSnow.id){
+                            fillerBlock = (short)Blocks.SANDSTONE.id;
+                        } else if(biome == Biomes.OVERWORLD_GLACIER && fillerBlock == Blocks.BLOCK_SNOW.id){
                             currentLayerDepth = rand.nextInt(8) + 14;
-                            fillerBlock = (short)Block.permafrost.id;
+                            fillerBlock = (short)Blocks.PERMAFROST.id;
                         }
                     }
                 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
index 997c3d682..f4985fb38 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.TerrainGeneratorLerp;
@@ -30,15 +31,15 @@ public class TerrainGeneratorOverworld
 
         if (y <= type.getMinY() + rand.nextInt(5))
         {
-            return Block.bedrock.id;
+            return Blocks.BEDROCK.id;
         }
         else if (density > 0.0)
         {
-            return type.getFillerBlock();
+            return type.getFillerBlockId();
         }
         else if (y >= type.getMinY() && y < type.getMinY() + type.getOceanY())
         {
-            return type.getOceanBlock();
+            return type.getOceanBlockId();
         }
 
         return 0;
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
index 8ebbdc646..ecfc7652b 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
@@ -1,7 +1,14 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld.hell;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSand;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.CoalOreBlock;
+import net.minecraft.core.block.DiamondOreBlock;
+import net.minecraft.core.block.GoldOreBlock;
+import net.minecraft.core.block.IronOreBlock;
+import net.minecraft.core.block.LapisOreBlock;
+import net.minecraft.core.block.RedstoneOreBlock;
+import net.minecraft.core.block.SandBlock;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.Chunk;
@@ -38,7 +45,7 @@ public class ChunkDecoratorOverworldHell
 
         float oreHeightModifier = rangeY / 128f;
 
-        BlockSand.fallInstantly = true;
+        SandBlock.fallInstantly = true;
         int x = chunkX * 16;
         int z = chunkZ * 16;
         int y = world.getHeightValue(x + 16, z + 16);
@@ -53,7 +60,7 @@ public class ChunkDecoratorOverworldHell
             int i1 = x + rand.nextInt(16) + 8;
             int l4 = minY + rand.nextInt(rangeY);
             int i8 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLake(Block.fluidLavaStill.id)).generate(world, rand, i1, l4, i8);
+            (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id)).place(world, rand, i1, l4, i8);
         }
         if(rand.nextInt(16) == 0)
         {
@@ -65,11 +72,11 @@ public class ChunkDecoratorOverworldHell
             {
                 if(rand.nextInt(4) == 0)
                 {
-                    (new WorldFeatureLake(Block.obsidian.id)).generate(world, rand, j1, i5, j8);
+                    (new WorldFeatureLake(Blocks.OBSIDIAN.id)).place(world, rand, j1, i5, j8);
                 }
                 else
                 {
-                    (new WorldFeatureLake(Block.fluidLavaStill.id)).generate(world, rand, j1, i5, j8);
+                    (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id)).place(world, rand, j1, i5, j8);
                 }
             }
         }
@@ -80,7 +87,7 @@ public class ChunkDecoratorOverworldHell
             int k23 = minY + rand.nextInt(rangeY / 2);
             int l24 = z + rand.nextInt(16) + 8;
             if(k23 < minY + rangeY / 2) {
-                (new WorldFeatureLiquid(Block.fluidWaterFlowing.id)).generate(world, rand, l21, k23, l24);
+                (new WorldFeatureLiquid(Blocks.FLUID_WATER_FLOWING.id)).place(world, rand, l21, k23, l24);
             }
         }
         for(int k1 = 0; k1 < 8; k1++)
@@ -90,11 +97,11 @@ public class ChunkDecoratorOverworldHell
             int j11 = z + rand.nextInt(16) + 8;
             if (rand.nextInt(2) == 0)
             {
-                (new WorldFeatureDungeon(Block.brickClay.id, Block.brickClay.id, null)).generate(world, rand, j5, k8, j11);
+                (new WorldFeatureDungeon(Blocks.BRICK_CLAY.id, Blocks.BRICK_CLAY.id, null)).place(world, rand, j5, k8, j11);
             }
             else
             {
-                (new WorldFeatureDungeon(Block.cobbleStone.id, Block.cobbleStoneMossy.id, null)).generate(world, rand, j5, k8, j11);
+                (new WorldFeatureDungeon(Blocks.COBBLE_STONE.id, Blocks.COBBLE_STONE_MOSSY.id, null)).place(world, rand, j5, k8, j11);
             }
         }
 
@@ -109,7 +116,7 @@ public class ChunkDecoratorOverworldHell
                 k8 -= rand.nextInt(10)+30;
 
             if(rand.nextInt(512) == 0) {
-                (new WorldFeatureLabyrinth()).generate(world, rand, j5, k8, j11);
+                (new WorldFeatureLabyrinth()).place(world, rand, j5, k8, j11);
             }
         }
 
@@ -118,7 +125,7 @@ public class ChunkDecoratorOverworldHell
             int k5 = x + rand.nextInt(16);
             int l8 = minY + rand.nextInt(rangeY);
             int k11 = z + rand.nextInt(16);
-            (new WorldFeatureClay(32)).generate(world, rand, k5, l8, k11);
+            (new WorldFeatureClay(32)).place(world, rand, k5, l8, k11);
         }
 
         for(int j2 = 0; j2 < 20; j2++)
@@ -126,7 +133,7 @@ public class ChunkDecoratorOverworldHell
             int l5 = x + rand.nextInt(16);
             int i9 = minY + rand.nextInt(rangeY);
             int l11 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.dirt.id, 32, false)).generate(world, rand, l5, i9, l11);
+            (new WorldFeatureOre(Blocks.DIRT.id, 32)).place(world, rand, l5, i9, l11);
         }
 
         for(int k2 = 0; k2 < 10; k2++)
@@ -134,7 +141,7 @@ public class ChunkDecoratorOverworldHell
             int i6 = x + rand.nextInt(16);
             int j9 = minY + rand.nextInt(rangeY);
             int i12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.gravel.id, 32, false)).generate(world, rand, i6, j9, i12);
+            (new WorldFeatureOre(Blocks.GRAVEL.id, 32)).place(world, rand, i6, j9, i12);
         }
 
         for(int i3 = 0; i3 < 20; i3++)
@@ -142,7 +149,7 @@ public class ChunkDecoratorOverworldHell
             int j6 = x + rand.nextInt(16);
             int k9 = minY + rand.nextInt(rangeY);
             int j12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreCoalStone.id, 16, true)).generate(world, rand, j6, k9, j12);
+            (new WorldFeatureOre(CoalOreBlock.variantMap, 16)).place(world, rand, j6, k9, j12);
         }
 
         for(int j3 = 0; j3 < 20; j3++)
@@ -150,7 +157,7 @@ public class ChunkDecoratorOverworldHell
             int k6 = x + rand.nextInt(16);
             int l9 = minY + rand.nextInt(rangeY / 2);
             int k12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreIronStone.id, 8, true)).generate(world, rand, k6, l9, k12);
+            (new WorldFeatureOre(IronOreBlock.variantMap, 8)).place(world, rand, k6, l9, k12);
         }
 
         for(int k3 = 0; k3 < 2; k3++)
@@ -158,7 +165,7 @@ public class ChunkDecoratorOverworldHell
             int l6 = x + rand.nextInt(16);
             int i10 = minY + rand.nextInt(rangeY / 4);
             int l12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreGoldStone.id, 8, true)).generate(world, rand, l6, i10, l12);
+            (new WorldFeatureOre(GoldOreBlock.variantMap, 8)).place(world, rand, l6, i10, l12);
         }
 
         for(int l3 = 0; l3 < 8; l3++)
@@ -166,7 +173,7 @@ public class ChunkDecoratorOverworldHell
             int i7 = x + rand.nextInt(16);
             int j10 = minY + rand.nextInt(rangeY / 8);
             int i13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreRedstoneStone.id, 7, true)).generate(world, rand, i7, j10, i13);
+            (new WorldFeatureOre(RedstoneOreBlock.variantMap, 7)).place(world, rand, i7, j10, i13);
         }
 
         for(int i4 = 0; i4 < 1; i4++)
@@ -174,7 +181,7 @@ public class ChunkDecoratorOverworldHell
             int j7 = x + rand.nextInt(16);
             int k10 = minY + rand.nextInt(rangeY / 8);
             int j13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreDiamondStone.id, 7, true)).generate(world, rand, j7, k10, j13);
+            (new WorldFeatureOre(DiamondOreBlock.variantMap, 7)).place(world, rand, j7, k10, j13);
         }
 
         for(int j4 = 0; j4 < 1; j4++)
@@ -182,7 +189,7 @@ public class ChunkDecoratorOverworldHell
             int k7 = x + rand.nextInt(16);
             int l10 = minY + rand.nextInt(rangeY / 8) + rand.nextInt(rangeY / 8);
             int k13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreLapisStone.id, 6, true)).generate(world, rand, k7, l10, k13);
+            (new WorldFeatureOre(LapisOreBlock.variantMap, 6)).place(world, rand, k7, l10, k13);
         }
 
         d = 0.5D;
@@ -201,13 +208,13 @@ public class ChunkDecoratorOverworldHell
             WorldFeature wf;
             if(rand.nextInt(10) == 0)
             {
-                wf = new WorldFeatureTreeFancy(hasLeaves ? Block.leavesOak.id : 0, Block.logOak.id);
+                wf = new WorldFeatureTreeFancy(hasLeaves ? Blocks.LEAVES_OAK.id : 0, Blocks.LOG_OAK.id);
             } else
             {
-                wf = new WorldFeatureTree(hasLeaves ? Block.leavesOak.id : 0, Block.logOak.id, 4);
+                wf = new WorldFeatureTree(hasLeaves ? Blocks.LEAVES_OAK.id : 0, Blocks.LOG_OAK.id, 4);
             }
-            wf.func_517_a(1.0D, 1.0D, 1.0D);
-            wf.generate(world, rand, l13, world.getHeightValue(l13, j14), j14);
+            wf.init(1.0D, 1.0D, 1.0D);
+            wf.place(world, rand, l13, world.getHeightValue(l13, j14), j14);
         }
 
         byte byte1 = 10;
@@ -216,7 +223,7 @@ public class ChunkDecoratorOverworldHell
             int i17 = x + rand.nextInt(16) + 8;
             int i20 = minY + rand.nextInt(rangeY);
             int l22 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureDeadBush(Block.deadbush.id)).generate(world, rand, i17, i20, l22);
+            (new WorldFeatureDeadBush(Blocks.DEADBUSH.id)).place(world, rand, i17, i20, l22);
         }
 
         for(int l18 = 0; l18 < 5; l18++)
@@ -224,7 +231,7 @@ public class ChunkDecoratorOverworldHell
             int l21 = x + rand.nextInt(16) + 8;
             int k23 = minY + rand.nextInt(rand.nextInt(rangeY - 8) + 8);
             int l24 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLiquid(Block.fluidLavaFlowing.id)).generate(world, rand, l21, k23, l24);
+            (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id)).place(world, rand, l21, k23, l24);
         }
 
         for(int i19 = 0; i19 < 20; i19++)
@@ -232,15 +239,15 @@ public class ChunkDecoratorOverworldHell
             int i22 = x + rand.nextInt(16) + 8;
             int l23 = minY + rand.nextInt(rand.nextInt(rand.nextInt(rangeY - rangeY / 8) + 8) + 8);
             int i25 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLiquid(Block.fluidLavaFlowing.id)).generate(world, rand, i22, l23, i25);
+            (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id)).place(world, rand, i22, l23, i25);
         }
 
-        if (world.getBlockId(x, minY + world.getWorldType().getOceanY() - 1, z) == world.getWorldType().getOceanBlock())
+        if (world.getBlockId(x, minY + world.getWorldType().getOceanY() - 1, z) == world.getWorldType().getOceanBlockId())
         {
-            world.setBlockWithNotify(x, minY + world.getWorldType().getOceanY() - 1, z, world.getWorldType().getOceanBlock());
+            world.setBlockWithNotify(x, minY + world.getWorldType().getOceanY() - 1, z, world.getWorldType().getOceanBlockId());
         }
 
-        BlockSand.fallInstantly = false;
+        SandBlock.fallInstantly = false;
 
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
index 60cdbf577..9c0f4cc33 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
@@ -1,7 +1,12 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld.retro;
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSand;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.CoalOreBlock;
+import net.minecraft.core.block.DiamondOreBlock;
+import net.minecraft.core.block.GoldOreBlock;
+import net.minecraft.core.block.IronOreBlock;
+import net.minecraft.core.block.RedstoneOreBlock;
+import net.minecraft.core.block.SandBlock;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
@@ -41,7 +46,7 @@ public class ChunkDecoratorOverworldRetro
         int maxY = world.getWorldType().getMaxY();
         int rangeY = (maxY + 1) - minY;
 
-        BlockSand.fallInstantly = true;
+        SandBlock.fallInstantly = true;
         int k = chunkX * 16;
         int l = chunkZ * 16;
         Random rand = new Random(world.getRandomSeed());
@@ -54,7 +59,7 @@ public class ChunkDecoratorOverworldRetro
             int i4 = k + rand.nextInt(16) + 8;
             int j6 = minY + rand.nextInt(rangeY);
             int i11 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureDungeon(Block.cobbleStone.id, Block.cobbleStoneMossy.id, null)).generate(world, rand, i4, j6, i11);
+            (new WorldFeatureDungeon(Blocks.COBBLE_STONE.id, Blocks.COBBLE_STONE_MOSSY.id, null)).place(world, rand, i4, j6, i11);
         }
 
         for (int j1 = 0; j1 < 10; j1++)
@@ -62,7 +67,7 @@ public class ChunkDecoratorOverworldRetro
             int j4 = k + rand.nextInt(16);
             int k6 = minY + rand.nextInt(rangeY);
             int j11 = l + rand.nextInt(16);
-            (new WorldFeatureClay(32)).generate(world, rand, j4, k6, j11);
+            (new WorldFeatureClay(32)).place(world, rand, j4, k6, j11);
         }
 
         for (int k1 = 0; k1 < 20; k1++)
@@ -70,7 +75,7 @@ public class ChunkDecoratorOverworldRetro
             int k4 = k + rand.nextInt(16);
             int l6 = minY + rand.nextInt(rangeY);
             int k11 = l + rand.nextInt(16);
-            (new WorldFeatureOre(Block.dirt.id, 32, false)).generate(world, rand, k4, l6, k11);
+            (new WorldFeatureOre(Blocks.DIRT.id, 32)).place(world, rand, k4, l6, k11);
         }
 
         for (int i2 = 0; i2 < 10; i2++)
@@ -78,7 +83,7 @@ public class ChunkDecoratorOverworldRetro
             int l4 = k + rand.nextInt(16);
             int i7 = minY + rand.nextInt(rangeY);
             int l11 = l + rand.nextInt(16);
-            (new WorldFeatureOre(Block.gravel.id, 32, false)).generate(world, rand, l4, i7, l11);
+            (new WorldFeatureOre(Blocks.GRAVEL.id, 32)).place(world, rand, l4, i7, l11);
         }
 
         for (int j2 = 0; j2 < 20; j2++)
@@ -86,7 +91,7 @@ public class ChunkDecoratorOverworldRetro
             int i5 = k + rand.nextInt(16);
             int j7 = minY + rand.nextInt(rangeY);
             int i12 = l + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreCoalStone.id, 16, true)).generate(world, rand, i5, j7, i12);
+            (new WorldFeatureOre(CoalOreBlock.variantMap, 16)).place(world, rand, i5, j7, i12);
         }
 
         for (int k2 = 0; k2 < 20; k2++)
@@ -94,7 +99,7 @@ public class ChunkDecoratorOverworldRetro
             int j5 = k + rand.nextInt(16);
             int k7 = minY + rand.nextInt(rangeY / 2);
             int j12 = l + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreIronStone.id, 8, true)).generate(world, rand, j5, k7, j12);
+            (new WorldFeatureOre(IronOreBlock.variantMap, 8)).place(world, rand, j5, k7, j12);
         }
 
         for (int i3 = 0; i3 < 2; i3++)
@@ -102,7 +107,7 @@ public class ChunkDecoratorOverworldRetro
             int k5 = k + rand.nextInt(16);
             int l7 = minY + rand.nextInt(rangeY / 4);
             int k12 = l + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreGoldStone.id, 8, true)).generate(world, rand, k5, l7, k12);
+            (new WorldFeatureOre(GoldOreBlock.variantMap, 8)).place(world, rand, k5, l7, k12);
         }
 
         for (int j3 = 0; j3 < 8; j3++)
@@ -110,7 +115,7 @@ public class ChunkDecoratorOverworldRetro
             int l5 = k + rand.nextInt(16);
             int i8 = minY + rand.nextInt(rangeY / 8);
             int l12 = l + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreRedstoneStone.id, 7, true)).generate(world, rand, l5, i8, l12);
+            (new WorldFeatureOre(RedstoneOreBlock.variantMap, 7)).place(world, rand, l5, i8, l12);
         }
 
         for (int k3 = 0; k3 < 1; k3++)
@@ -118,7 +123,7 @@ public class ChunkDecoratorOverworldRetro
             int i6 = k + rand.nextInt(16);
             int j8 = minY + rand.nextInt(rangeY / 8);
             int i13 = l + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreDiamondStone.id, 7, true)).generate(world, rand, i6, j8, i13);
+            (new WorldFeatureOre(DiamondOreBlock.variantMap, 7)).place(world, rand, i6, j8, i13);
         }
 
         d = 0.5D;
@@ -131,17 +136,17 @@ public class ChunkDecoratorOverworldRetro
         {
             l3++;
         }
-        Object obj = new WorldFeatureTree(Block.leavesOakRetro.id, Block.logOak.id, 4);
+        Object obj = new WorldFeatureTree(Blocks.LEAVES_OAK_RETRO.id, Blocks.LOG_OAK.id, 4);
         if (rand.nextInt(10) == 0)
         {
-            obj = new WorldFeatureTreeFancy(Block.leavesOakRetro.id, Block.logOak.id);
+            obj = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id, Blocks.LOG_OAK.id);
         }
         for (int k8 = 0; k8 < l3; k8++)
         {
             int j13 = k + rand.nextInt(16) + 8;
             int l15 = l + rand.nextInt(16) + 8;
-            ((WorldFeature)(obj)).func_517_a(1.0D, 1.0D, 1.0D);
-            ((WorldFeature)(obj)).generate(world, rand, j13, world.getHeightValue(j13, l15), l15);
+            ((WorldFeature)(obj)).init(1.0D, 1.0D, 1.0D);
+            ((WorldFeature)(obj)).place(world, rand, j13, world.getHeightValue(j13, l15), l15);
         }
 
         for (int l8 = 0; l8 < 2; l8++)
@@ -149,7 +154,7 @@ public class ChunkDecoratorOverworldRetro
             int k13 = k + rand.nextInt(16) + 8;
             int i16 = minY + rand.nextInt(rangeY);
             int j18 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Block.flowerYellow.id)).generate(world, rand, k13, i16, j18);
+            (new WorldFeatureFlowers(Blocks.FLOWER_YELLOW.id)).place(world, rand, k13, i16, j18);
         }
 
         if (rand.nextInt(2) == 0)
@@ -157,28 +162,28 @@ public class ChunkDecoratorOverworldRetro
             int i9 = k + rand.nextInt(16) + 8;
             int l13 = minY + rand.nextInt(rangeY);
             int j16 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Block.flowerRed.id)).generate(world, rand, i9, l13, j16);
+            (new WorldFeatureFlowers(Blocks.FLOWER_RED.id)).place(world, rand, i9, l13, j16);
         }
         if (rand.nextInt(4) == 0)
         {
             int j9 = k + rand.nextInt(16) + 8;
             int i14 = minY + rand.nextInt(rangeY);
             int k16 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Block.mushroomBrown.id)).generate(world, rand, j9, i14, k16);
+            (new WorldFeatureFlowers(Blocks.MUSHROOM_BROWN.id)).place(world, rand, j9, i14, k16);
         }
         if (rand.nextInt(8) == 0)
         {
             int k9 = k + rand.nextInt(16) + 8;
             int j14 = minY + rand.nextInt(rangeY);
             int l16 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Block.mushroomRed.id)).generate(world, rand, k9, j14, l16);
+            (new WorldFeatureFlowers(Blocks.MUSHROOM_RED.id)).place(world, rand, k9, j14, l16);
         }
         for (int l9 = 0; l9 < 10; l9++)
         {
             int k14 = k + rand.nextInt(16) + 8;
             int i17 = minY + rand.nextInt(rangeY);
             int k18 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureSugarCane()).generate(world, rand, k14, i17, k18);
+            (new WorldFeatureSugarCane()).place(world, rand, k14, i17, k18);
         }
 
         for (int i10 = 0; i10 < 1; i10++)
@@ -186,7 +191,7 @@ public class ChunkDecoratorOverworldRetro
             int l14 = k + rand.nextInt(16) + 8;
             int j17 = minY + rand.nextInt(rangeY);
             int l18 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureCactus()).generate(world, rand, l14, j17, l18);
+            (new WorldFeatureCactus()).place(world, rand, l14, j17, l18);
         }
 
         for (int j10 = 0; j10 < 50; j10++)
@@ -194,7 +199,7 @@ public class ChunkDecoratorOverworldRetro
             int i15 = k + rand.nextInt(16) + 8;
             int k17 = minY + rand.nextInt(rand.nextInt(rangeY - 8) + 8);
             int i19 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureLiquid(Block.fluidWaterFlowing.id)).generate(world, rand, i15, k17, i19);
+            (new WorldFeatureLiquid(Blocks.FLUID_WATER_FLOWING.id)).place(world, rand, i15, k17, i19);
         }
 
         for (int k10 = 0; k10 < 20; k10++)
@@ -202,7 +207,7 @@ public class ChunkDecoratorOverworldRetro
             int j15 = k + rand.nextInt(16) + 8;
             int l17 = minY + rand.nextInt(rand.nextInt(rand.nextInt(rangeY / 2 - rangeY / 8) + 8) + 8);
             int j19 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureLiquid(Block.fluidLavaFlowing.id)).generate(world, rand, j15, l17, j19);
+            (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id)).place(world, rand, j15, l17, j19);
         }
 
         for (int l10 = k + 8 + 0; l10 < k + 8 + 16; l10++)
@@ -212,17 +217,17 @@ public class ChunkDecoratorOverworldRetro
                 int i18 = world.findTopSolidBlock(l10, k15);
                 if (snowCovered && i18 > minY && i18 <= maxY && world.getBlockId(l10, i18, k15) == 0 && world.getBlockMaterial(l10, i18 - 1, k15).blocksMotion() && world.getBlockMaterial(l10, i18 - 1, k15) != Material.ice)
                 {
-                    world.setBlockWithNotify(l10, i18, k15, Block.layerSnow.id);
+                    world.setBlockWithNotify(l10, i18, k15, Blocks.LAYER_SNOW.id);
                 }
                 if (snowCovered && world.getBlockMaterial(l10, world.getWorldType().getOceanY() - 1, k15) == Material.water)
                 {
-                    world.setBlockWithNotify(l10, world.getWorldType().getOceanY() - 1, k15, Block.ice.id);
+                    world.setBlockWithNotify(l10, world.getWorldType().getOceanY() - 1, k15, Blocks.ICE.id);
                 }
             }
 
         }
 
-        BlockSand.fallInstantly = false;
+        SandBlock.fallInstantly = false;
         world.scheduledUpdatesAreImmediate = false;
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java
index c85406a47..bbc3f5834 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java
@@ -30,7 +30,7 @@ public class TerrainGeneratorParadise
 
         if (density > 0.0)
         {
-            return type.getFillerBlock();
+            return type.getFillerBlockId();
         }
 
         return 0;
